//   W25Q64
#include "DF_Servis.h"                                          // 

static volatile unsigned char    ErBl_Bufer[ErBlSize];          //    
static volatile unsigned long    ANomBl;                        //     
static volatile unsigned char    Modified;                      //    
static volatile unsigned long    AWRPointSize;                  // / 
static volatile unsigned char    AFileStarted;                  //  
static volatile unsigned long    LogWrPoint;                    //   
static volatile unsigned long    LogSize;                       //    
static volatile unsigned char    LogModified;                   //   
static volatile unsigned short   DF_O_PIN = DF_MISO_PIN;        //  
static volatile unsigned short   DF_S_PIN = DF_SCK_PIN;

//-----------------------------------------------------------------------------------------------------------------------
extern TKnt             Knt;                                    // 

//-----------------------------------------------------------------------------------------------------------------------
// 
void DF_RdLogPar(void);                                         //  

//-----------------------------------------------------------------------------------------------------------------------
//  
void InitW25(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;                         //  

  //Enable GPIO clock
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOE, ENABLE);
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
  //Configure the DF_SCK_PIN as output
  GPIO_InitStructure.GPIO_Pin = DF_SCK_PIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_Init(DF_SCK_PORT, &GPIO_InitStructure);
  //Configure the DF_O_PIN as output
  GPIO_InitStructure.GPIO_Pin = DF_MISO_PIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_Init(DF_MISO_PORT, &GPIO_InitStructure);
  //Configure the DF_MOSI_PIN as input
  GPIO_InitStructure.GPIO_Pin = DF_MOSI_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_PuPd =  GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_Init(DF_MOSI_PORT, &GPIO_InitStructure);
  //Configure the DF_CS0 pin as output
  GPIO_InitStructure.GPIO_Pin = DF_CS0_PIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_Init(DF_CS0_PORT, &GPIO_InitStructure);
}  
//-----------------------------------------------------------------------------------------------------------------------
//   IO_0
void Set_IO0_Mode(unsigned char Mode)
{
  GPIO_InitTypeDef  GPIO_InitStructure;                         //  

  if (Mode)                                                     // 
  {
    //Configure the DF_O_PIN as output
    GPIO_InitStructure.GPIO_Pin = DF_MISO_PIN;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_Init(DF_MISO_PORT, &GPIO_InitStructure);
  }
  else                                                          //
  {
    //Configure the DF_O_PIN as input
    GPIO_InitStructure.GPIO_Pin = DF_MISO_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
    GPIO_InitStructure.GPIO_PuPd =  GPIO_PuPd_NOPULL;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
    GPIO_Init(DF_MISO_PORT, &GPIO_InitStructure);
  }
}  
//-----------------------------------------------------------------------------------------------------------------------
// CS
void CS_On(void)
{ 
  GPIO_ResetBits(DF_CS0_PORT, DF_CS0_PIN);                      //   
  __ASM volatile ("NOP");                                       //   
}
//-----------------------------------------------------------------------------------------------------------------------
//  CS
void CS_AllOff(void)
{ 
  GPIO_SetBits(DF_CS0_PORT, DF_CS0_PIN);                        //  CS
  __ASM volatile ("NOP");                                       //   
}
//-----------------------------------------------------------------------------------------------------------------------
//  DF
void DF_Init(void)
{
  InitW25();                                                    //  
  ANomBl = 0xFFFFFFFF;                                          //     ()
  AWRPointSize = 0;                                             // /  
  AFileStarted = 0;                                             //   
  Modified = 0;                                                 //   
  LogModified = 0;                                              //   
  CS_AllOff();                                                  //  CS
  DF_RdLogPar();                                                //  
}
//-----------------------------------------------------------------------------------------------------------------------
///   SPI,  
unsigned char DFTranserByte (unsigned char Data)
{
  unsigned char Res = 0x00;                                     //
  // 7
  if (Data & 0x80) DF_MISO_PORT->BSRRL = DF_O_PIN;              //1
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;              //0
  DF_SCK_PORT->BSRRL = DF_S_PIN;                                // 
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x80;             //  
  DF_SCK_PORT->BSRRH = DF_S_PIN;                                // 
  // 6
  if (Data & 0x40) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x40;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  // 5
  if (Data & 0x20) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x20;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  // 4
  if (Data & 0x10) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x10;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  // 3
  if (Data & 0x08) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x08;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  // 2
  if (Data & 0x04) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x04;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  // 1
  if (Data & 0x02) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x02;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  // 0
  if (Data & 0x01) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x01;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  
  return Res;                                                   //
}
//-----------------------------------------------------------------------------------------------------------------------
///   DUAL SPI,  
unsigned char DFTranserByte_DUAL (unsigned char Data)
{
  unsigned char Res = 0x00;                                     //
  // 3
  if (Data & 0x80) DF_MISO_PORT->BSRRL = DF_O_PIN;              //1
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;              //0
  DF_SCK_PORT->BSRRL = DF_S_PIN;                                // 
  if (DF_MISO_PORT->IDR & DF_MISO_PIN) Res |= 0x40;             //  
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x80;             //  
  DF_SCK_PORT->BSRRH = DF_S_PIN;                                // 
  // 2
  if (Data & 0x40) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MISO_PORT->IDR & DF_MISO_PIN) Res |= 0x10;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x20;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  // 1
  if (Data & 0x20) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MISO_PORT->IDR & DF_MISO_PIN) Res |= 0x04;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x08;
  DF_SCK_PORT->BSRRH = DF_S_PIN;
  // 0
  if (Data & 0x10) DF_MISO_PORT->BSRRL = DF_O_PIN;
  else             DF_MISO_PORT->BSRRH = DF_O_PIN;
  DF_SCK_PORT->BSRRL = DF_S_PIN;
  if (DF_MISO_PORT->IDR & DF_MISO_PIN) Res |= 0x01;
  if (DF_MOSI_PORT->IDR & DF_MOSI_PIN) Res |= 0x02;
  DF_SCK_PORT->BSRRH = DF_S_PIN;

  return Res;                                                   //
}
//-----------------------------------------------------------------------------------------------------------------------
//    
void SmallDel(volatile unsigned long Delay)
{
  Delay *= 22;
  while (Delay--);
}
//-----------------------------------------------------------------------------------------------------------------------
// 
void Wait_BUSY(void)
{
  unsigned char           Var;                                  //  
  unsigned char           WFl;                                  // 
  volatile unsigned short WtTmr;                                // 

  WFl = 1;                                                      // 
  WtTmr = 0;                                                    //    

  while (WFl)                                                   //     
  {
    CS_On();                                                    // 
    DFTranserByte(0x05);                                        //   0
    Var = DFTranserByte(0x00);                                  // 
    CS_AllOff();                                                //   

    Var &= 0x01;                                                //  
    if (!Var) WFl = 0;                                          // 
    else      SmallDel(10);                                     // 

    WtTmr++;                                                    // 
    if (WtTmr > 10000) WFl = 0;                                 //  
  }  
}
//-----------------------------------------------------------------------------------------------------------------------
// 
void Write_ON(void)
{
  Wait_BUSY();                                                  // 
  CS_On();                                                      //  
  DFTranserByte(0x06);                                          //  
  CS_AllOff();                                                  //  ( )
}
//-----------------------------------------------------------------------------------------------------------------------
//   
void Wr_Buf(unsigned long NBl)
{
  unsigned long  FullAdr;                                       //    ( )
  unsigned long  PgOffs;                                        //   
  unsigned short i, j;                                          //

  if (NBl > MaxErBlCnty) return;                                //   
  
  FullAdr = NBl * ErBlSize;                                     //    ( )
  //  
  Write_ON();                                                   // 
  Wait_BUSY();                                                  // 
  CS_On();                                                      //  
  DFTranserByte(0x20);                                          //  
  DFTranserByte((unsigned char)(FullAdr >> 16));                //  
  DFTranserByte((unsigned char)(FullAdr >> 8));
  DFTranserByte((unsigned char) FullAdr);
  CS_AllOff();                                                  //  ( )
  for (j = 0; j < WrPageInErBl; j++)                            //    
  {
    //  
    Write_ON();                                                 // 
    Wait_BUSY();                                                // 
    CS_On();                                                    //  
    DFTranserByte(0x02);                                        //  
    DFTranserByte((unsigned char)(FullAdr >> 16));              //   ()
    DFTranserByte((unsigned char)(FullAdr >> 8));
    DFTranserByte((unsigned char) FullAdr);
    FullAdr += WrPageSize;                                      //      
    PgOffs = j * WrPageSize;                                    //   
    // (  )
    for (i = 0; i < WrPageSize; i++) DFTranserByte(ErBl_Bufer[PgOffs + i]);
    CS_AllOff();                                                //  ( )
  }
  Modified = 0;                                                 //  -  
}
//-----------------------------------------------------------------------------------------------------------------------
//   dataflash
void Rd_Buf(unsigned long NBl)
{
  unsigned long  FullAdr;                                       //    ( )
  unsigned short i;                                             //

  if (NBl > MaxErBlCnty) return;                                //   
  
  FullAdr = NBl * ErBlSize;                                     //    ( )
  //  
  Wait_BUSY();                                                  // 
  CS_On();                                                      //  
  DFTranserByte(0x3B);                                          //    DUAL 
  DFTranserByte((unsigned char)(FullAdr >> 16));                //   ()
  DFTranserByte((unsigned char)(FullAdr >> 8));
  DFTranserByte((unsigned char) FullAdr);
  DFTranserByte(0x00);                                          //Dummy 
  Set_IO0_Mode(0);                                              //  
  for (i = 0; i < ErBlSize; i++) ErBl_Bufer[i] = DFTranserByte_DUAL(0x00);
  CS_AllOff();                                                  //  ( )
  Set_IO0_Mode(1);                                              //   
}
//-----------------------------------------------------------------------------------------------------------------------
//   
void Reload_Bufer(unsigned long New_Nom)
{
  if (Modified) Wr_Buf(ANomBl);                                 //    DataFlash,     
  Rd_Buf(New_Nom);                                              //    DataFlash
  ANomBl = New_Nom;                                             //   
}
//-----------------------------------------------------------------------------------------------------------------------
//   FAT
void Wr_Buf_FAT(unsigned long Sector, unsigned char *Buf)
{
  unsigned long  NBl;                                           // 
  unsigned long  BlOffs;                                        //  
  unsigned short i;                                             // 

  Sector += FirstFATSec;                                        //   
  if (Sector >= MaxFSector) return;                             //  
  
  NBl = (Sector * 512) / ErBlSize;                              // 
  BlOffs = (Sector * 512) % ErBlSize;                           //   ()

  if (ANomBl != NBl) Reload_Bufer(NBl);                         //       -  
  for (i = 0; i <= 511; i++) ErBl_Bufer[BlOffs + i] = Buf[i];   //   
  Modified = 1;                                                 //   
}
//-----------------------------------------------------------------------------------------------------------------------
//   FAT
void Rd_Buf_FAT(unsigned long Sector, unsigned char *Buf)
{
  unsigned long  FullAdr;                                       //    ( )
  unsigned short i;                                             // 
  
  Sector += FirstFATSec;                                        //   
  if (Sector >= MaxFSector) return;                             //  
  
  if (Modified) Wr_Buf(ANomBl);                                 //    DataFlash,     
  FullAdr = Sector * 512;                                       //    ( )
  Wait_BUSY();                                                  // 
  //   DUAL 
  CS_On();                                                      //  
  DFTranserByte(0x3B);                                          //    DUAL 
  DFTranserByte((unsigned char)(FullAdr >> 16));                //   ()
  DFTranserByte((unsigned char)(FullAdr >> 8));
  DFTranserByte((unsigned char) FullAdr);
  DFTranserByte(0x00);                                          //Dummy 
  Set_IO0_Mode(0);                                              //  
  for (i = 0; i < 512; i++) Buf[i] = DFTranserByte_DUAL(0x00);
  CS_AllOff();                                                  //  ( )
  Set_IO0_Mode(1);                                              //   
}
//------------------------------------------------------------------------------
//   
unsigned short IncParByVlForLog(unsigned char *BF, signed short Val)
{
  unsigned char  LNString[40];                                  //  
  unsigned short AddedSimv = 0;                                 //  

  //   
  if      (Val == kYes)          AddedSimv = StrInBuf(BF, "Yes");
  else if (Val == kNo)           AddedSimv = StrInBuf(BF, "No");
  else if (Val == kNotDef)       AddedSimv = StrInBuf(BF, "NotDef");
  else if (Val == kOK)           AddedSimv = StrInBuf(BF, "OK");
  else if (Val == kOutOfService) AddedSimv = StrInBuf(BF, "OutOfService");
  else if (Val == kAlarm)        AddedSimv = StrInBuf(BF, "Alarm");
  else if (Val == kAlarmPos)     AddedSimv = StrInBuf(BF, "AlarmPos");
  else if (Val == kAlarmNeg)     AddedSimv = StrInBuf(BF, "AlarmNeg");
  else if (Val == kNoAlarm)      AddedSimv = StrInBuf(BF, "NoAlarm");
  else if (Val >= 0)                                            //     
  {
    ultoa(Val, LNString);                                       //  
    AddedSimv = StrInBuf(BF, (char*)LNString);                  //   
  } else AddedSimv = StrInBuf(BF, "---");                       // 
  
  return AddedSimv;                                             //   
}
//-----------------------------------------------------------------------------------------------------------------------
//  
void DF_WrLogRec(unsigned char *Text, signed short A1, signed short A2, signed short A3)
{
  unsigned long  N_Bl;                                          // 
  unsigned short Adr_Bl;                                        //  
  unsigned char  LNString[40];                                  //  
  unsigned short WrPntr;                                        // 

  //    
  if (strlen((char const*)Text) >= 50) Text = ",    ";
  
  N_Bl = FirstLogSec/8 + (LogWrPoint / RecPerBl);               //  
  Adr_Bl = (LogWrPoint % RecPerBl) * MaxLogRecSize;             //  

  if (ANomBl != N_Bl) Reload_Bufer(N_Bl);                       //       -  
  LogWrPoint++;                                                 //   
  if (LogWrPoint >= MaxNRec) LogWrPoint = 0;                    // 
  if (LogSize < MaxNRec) LogSize++;                             //     
  
  WrPntr = Adr_Bl;                                              //      
  WrPntr += StrInBuf((unsigned char*)&ErBl_Bufer[WrPntr], (char*)"<LRec T=\""); //   (XML   )
  ATimeToStr(LNString, &Knt.DTime);                             //     
  // 
  WrPntr += StrInBuf((unsigned char*)&ErBl_Bufer[WrPntr], (char*)LNString);
  WrPntr += StrInBuf((unsigned char*)&ErBl_Bufer[WrPntr], (char*)"\" A1=\"");
  // 1
  WrPntr += IncParByVlForLog((unsigned char*)&ErBl_Bufer[WrPntr], A1);
  WrPntr += StrInBuf((unsigned char*)&ErBl_Bufer[WrPntr], (char*)"\" A2=\"");
  // 2
  WrPntr += IncParByVlForLog((unsigned char*)&ErBl_Bufer[WrPntr], A2);
  WrPntr += StrInBuf((unsigned char*)&ErBl_Bufer[WrPntr], (char*)"\" A3=\"");
  // 3
  WrPntr += IncParByVlForLog((unsigned char*)&ErBl_Bufer[WrPntr], A3);
  // 
  WrPntr += StrInBuf((unsigned char*)&ErBl_Bufer[WrPntr], (char*)"\">");
  //   
  while(*Text)                                                  //  
  {
    ErBl_Bufer[WrPntr] = *Text++;                               // 
    WrPntr++;                                                   //  
  }
  //    
  WrPntr += StrInBuf((unsigned char*)&ErBl_Bufer[WrPntr], (char*)"</LRec>\r\n");
  ErBl_Bufer[WrPntr] = 0x00;                                    // 
  
  Modified = 1;                                                 //     
  LogModified = 1;                                              //   
}
//-----------------------------------------------------------------------------------------------------------------------
//  
unsigned short DF_RdLogRec(unsigned char *Text, unsigned long NRecFromEnd)
{
  unsigned long  ARec;                                          //  
  unsigned long  N_Bl;                                          // 
  unsigned short Adr_Bl;                                        //  

  if (NRecFromEnd >= LogSize) return 0;                         //    

  NRecFromEnd++;                                                //  -   ,        
  if (LogWrPoint >= NRecFromEnd) ARec = LogWrPoint - NRecFromEnd;             //      
  else                           ARec = MaxNRec - (NRecFromEnd - LogWrPoint); //  
  
  N_Bl = FirstLogSec/8 + (ARec / RecPerBl);                     //    
  Adr_Bl = (ARec % RecPerBl) * MaxLogRecSize;                   //  

  if (ANomBl != N_Bl) Reload_Bufer(N_Bl);                       //       -  
  
  return StrInBuf(Text, (char*)&ErBl_Bufer[Adr_Bl]);            //       
}
//-----------------------------------------------------------------------------------------------------------------------
//  
void DF_RdLogPar(void)
{
  unsigned long SZ1, SZ2, SZ3, SZ4;                             // 
  unsigned long FLogBl = FirstLogSec / 8;                       //    

  if (ANomBl != FLogBl) Reload_Bufer(FLogBl);                   //   
  //     1-      4000
  SZ1 = ErBl_Bufer[4000];
  SZ2 = ErBl_Bufer[4001];
  SZ3 = ErBl_Bufer[4002];
  SZ4 = ErBl_Bufer[4003];
  LogWrPoint = (SZ1 << 24) | (SZ2 << 16) | (SZ3 << 8) | SZ4;    //   
  
  SZ1 = ErBl_Bufer[4004];
  SZ2 = ErBl_Bufer[4005];
  SZ3 = ErBl_Bufer[4006];
  SZ4 = ErBl_Bufer[4007];
  LogSize = (SZ1 << 24) | (SZ2 << 16) | (SZ3 << 8) | SZ4;       //    
}
//-----------------------------------------------------------------------------------------------------------------------
//  
void DF_WrLogPar(void)
{
  unsigned long FLogBl = FirstLogSec / 8;                       //    
  if (ANomBl != FLogBl) Reload_Bufer(FLogBl);                   //   
  //     1-      4000
  ErBl_Bufer[4000] = (LogWrPoint >> 24) & 0x000000FF;           //   
  ErBl_Bufer[4001] = (LogWrPoint >> 16) & 0x000000FF;
  ErBl_Bufer[4002] = (LogWrPoint >> 8)  & 0x000000FF;
  ErBl_Bufer[4003] =  LogWrPoint        & 0x000000FF;
  
  ErBl_Bufer[4004] = (LogSize >> 24) & 0x000000FF;              //    
  ErBl_Bufer[4005] = (LogSize >> 16) & 0x000000FF;
  ErBl_Bufer[4006] = (LogSize >> 8)  & 0x000000FF;
  ErBl_Bufer[4007] =  LogSize        & 0x000000FF;
  Modified = 1;                                                 //     
  Wr_Buf(ANomBl);                                               //   dataflash
}
//-----------------------------------------------------------------------------------------------------------------------
//   
//          Flash 
//     ,    
void DF_DelayedWrLogPar(void)
{
  static unsigned char DelTimer = 0;                            //  

  if (LogModified)                                              //    
  {
    DelTimer++;                                                 // 
    if (DelTimer >= 10)                                         //  
    {
      DF_WrLogPar();                                            //  
      DelTimer = 0;                                             //    
      LogModified = 0;                                          // 
    }
  }
}
//-----------------------------------------------------------------------------------------------------------------------
//  
unsigned long DF_GetLogSize(void)
{
  return LogSize;                                               // 
}
//-----------------------------------------------------------------------------------------------------------------------
// 
void DF_ClearLog(void)
{
  LogWrPoint = 0;                                               //   
  LogSize = 0;                                                  //    
  DF_WrLogPar();                                                //  
}
//-----------------------------------------------------------------------------------------------------------------------
//  
void DF_Wr_File(unsigned long Adr, unsigned char Dat)
{
  unsigned long  N_Bl;                                          // 
  unsigned short Adr_Bl;                                        //  

  if (Adr < Max_Sz_File+10)                                     // 
  {
    //+1      
    N_Bl = (unsigned long)Adr / ErBlSize + 1;                   // 
    Adr_Bl = (unsigned long)Adr % ErBlSize;                     //  

    if (ANomBl != N_Bl) Reload_Bufer(N_Bl);                     //    -  
    ErBl_Bufer[Adr_Bl] = Dat;                                   //  
    Modified = 1;                                               //   
  }
}
//-----------------------------------------------------------------------------------------------------------------------
//   
void DF_File_WriteBf(unsigned char *Ptr, unsigned short Size)
{
  unsigned long i;                                              //
  
  for(i = 0; i < Size; i++)                                     //   
  {
    DF_Wr_File(AWRPointSize, Ptr[i]);                           //  
    AWRPointSize++;                                             //  
  }
}
//-----------------------------------------------------------------------------------------------------------------------
//  
unsigned char DF_Rd_File(unsigned long Adr)
{
  unsigned char  Res;                                           //
  unsigned long  N_Bl;                                          // 
  unsigned short Adr_Bl;                                        //  

  if(Adr < (Max_Sz_File + 10))                                  //   
  {
    //+1      
    N_Bl = (unsigned long)Adr / ErBlSize + 1;                   // 
    Adr_Bl = (unsigned long)Adr % ErBlSize;                     //  

    if (ANomBl != N_Bl) Reload_Bufer(N_Bl);                     //    -  
    Res = ErBl_Bufer[Adr_Bl];                                   //    
  }
  else Res = 0;                                                 //  0

  return Res;                                                   //
}
//-----------------------------------------------------------------------------------------------------------------------
//  
void DF_Save_FSize(unsigned long Size)
{
  //         
  DF_Wr_File(Max_Sz_File+0, (Size >> 24) & 0x000000FF);         // 
  DF_Wr_File(Max_Sz_File+1, (Size >> 16) & 0x000000FF);
  DF_Wr_File(Max_Sz_File+2, (Size >> 8)  & 0x000000FF);
  DF_Wr_File(Max_Sz_File+3,  Size        & 0x000000FF);
}
//-----------------------------------------------------------------------------------------------------------------------
//  
unsigned long DF_Read_FSize(void)
{
  unsigned long SZ1, SZ2, SZ3, SZ4;                             // 
  unsigned long FSize;                                          // 

  //           
  SZ1 = DF_Rd_File(Max_Sz_File+0);                              // 
  SZ2 = DF_Rd_File(Max_Sz_File+1);
  SZ3 = DF_Rd_File(Max_Sz_File+2);
  SZ4 = DF_Rd_File(Max_Sz_File+3);

  FSize = (SZ1 << 24) | (SZ2 << 16) | (SZ3 << 8) | SZ4;         // 
  return FSize;                                                 // 
}
//-----------------------------------------------------------------------------------------------------------------------
// 
void DF_Open_File(void)
{
  AWRPointSize = 0;                                             // /  
  AFileStarted = 1;                                             //   
}
//-----------------------------------------------------------------------------------------------------------------------
//  -    
void DF_Close_File(void)
{
  if (AFileStarted)                                             //  
  {
    DF_Save_FSize(AWRPointSize);                                //  
    Wr_Buf(ANomBl);                                             //    dataflash
  }
}
//-----------------------------------------------------------------------------------------------------------------------
//  DataFlash
unsigned char Test_DF(unsigned char NChip)
{
  unsigned char  Var;                                           //  
  
  CS_On();                                                      // 
  DFTranserByte(0x90);                                          //  ID
  DFTranserByte(0x00);                                          //  
  DFTranserByte(0x00);
  DFTranserByte(0x00);
  Var = DFTranserByte(0x00);                                    // ID 
  DFTranserByte(0x00);                                          //ID  
  CS_AllOff();                                                  //   
  // 
  if (Var == 0xEF) return 1;                                    //   ( Winbond)
  else             return 0;                                    //
}
//-----------------------------------------------------------------------------------------------------------------------
//   
unsigned char Is_DF_Ready(void)
{
  //  FAT     
  if (Knt.DF_Present[0]) return 1;
  else                   return 0;
}
//------------------------------------------------------------------------------
//      
void SaveObj(unsigned long StorAdr, unsigned char *Data, unsigned short DataLen)
{
  unsigned long   i;                                            //
  unsigned char   *Ptr;                                         //  
  unsigned long   WrPntr;                                       // 

  if (ANomBl != kNDataBl) Reload_Bufer(kNDataBl);               //      -  
  Ptr = (unsigned char*)Data;                                   // 
  WrPntr = StorAdr;                                             //     
  for(i = 0; i < DataLen; i++)                                  // 
  {
    ErBl_Bufer[WrPntr] = Ptr[i];                                //  
    WrPntr++;                                                   //  
  }
  ErBl_Bufer[ErBlSize-1] = 0x7B;                                //ID     
  Wr_Buf(ANomBl);                                               //    DataFlash
}
//------------------------------------------------------------------------------
//   Flash
void LoadObj(unsigned long StorAdr, unsigned char *Data, unsigned short DataLen)
{
  unsigned long   i;                                            //
  unsigned char   *Ptr;                                         //  
  unsigned long   RdPntr;                                       // 
  
  if (ANomBl != kNDataBl) Reload_Bufer(kNDataBl);               //      -  
  Ptr = (unsigned char*)Data;                                   // 
  RdPntr = StorAdr;                                             //     
  for (i = 0; i < DataLen; i++)                                 // 
  {
    Ptr[i] = ErBl_Bufer[RdPntr];                                //  
    RdPntr++;                                                   //  
  }
}
//------------------------------------------------------------------------------
//       
//    Flash
unsigned char IsFlashClear(void)
{
  if (ANomBl != MaxErBlCnty) Reload_Bufer(MaxErBlCnty);         //      -  
  //    ID  
  if (ErBl_Bufer[ErBlSize-1] == 0x7B) return 0;                 //ID    
  else                                return 1;                 //  
}
//------------------------------------------------------------------------------
//        DF
void ApdBootInf(void)
{
  TBootConf  BtCnf;                                             //  
  
  BtCnf.MemID = 0x7A;                                           //ID   
  BtCnf.Crc32PrM = 0x00000000;                                  // CRC32    
  BtCnf.USoftSt = 0x09;                                         //  ,     
  SaveObj(kBootDataAdr, (unsigned char*)&BtCnf, sizeof(BtCnf)); //    
}
