//  DF_Servis.c
#ifndef DF_SERVICE_H
#define DF_SERVICE_H

#include <string.h>
#include "stm32f4xx_conf.h"
#include "TypeDefs.h"
#include "servis.h"

//---------------------------------------------------------------------------------------------------
//DF chip select 0
#define DF_CS0_PORT               GPIOE
#define DF_CS0_PIN                GPIO_Pin_3
// SPI
#define DF_SCK_PIN                GPIO_Pin_10
#define DF_SCK_PORT               GPIOB

#define DF_MOSI_PIN               GPIO_Pin_2
#define DF_MOSI_PORT              GPIOC

#define DF_MISO_PIN               GPIO_Pin_3
#define DF_MISO_PORT              GPIOC

//-----------------------------------------------------------------------------------------------
#define ErBlSize                  4096UL                        //   
#define WrPageSize                256UL                         //   
#define WrPageInErBl              16                            //     
#define MaxErBlCnty               2048UL                        //    
#define Max_Sz_File               2007000UL                     //   ( 490 )
#define BootFileOffset            3960UL                        //   512B    (  )(495 )
#define EventsLogOffset           1000UL                        //   512B   (  4KB)
#define MaxFSector                MaxErBlCnty*ErBlSize/512      //   
//   (512B)  FAT
#define MaxNSector                (MaxErBlCnty*ErBlSize/512 - BootFileOffset - EventsLogOffset)
//  FAT
#define FirstFATSec               (BootFileOffset + EventsLogOffset)
#define FirstLogSec               BootFileOffset                //   512B
#define RecPerBl                  40UL                          //     4096B
#define MaxNRec                   (EventsLogOffset*5)           //    (    512B)
#define MaxLogRecSize             100UL                         //   

#define kNDataBl                  0x00                          //    
#define kBootDataAdr              0x0UL                         //    FLASH   
#define kDataAdr                  0x10UL                        //    FLASH   

#define BlSizeToWr                100UL                         //      

//-------------------------------------------------------------------------------------------------
void DF_Init(void);                                             //  DF
unsigned char Test_DF(unsigned char NChip);                     // DataFlash
//      ( DF )
void DF_Save_FSize(unsigned long Size);                         //  
unsigned long DF_Read_FSize(void);                              //  
void DF_Open_File(void);                                        // 
void DF_Close_File(void);                                       //  -    
unsigned char DF_Rd_File(unsigned long Adr);                    //  
void DF_File_WriteBf(unsigned char *Ptr, unsigned short Size);  //   
void Wr_Buf_FAT(unsigned long Sector, unsigned char *Buf);      //   FAT
void Rd_Buf_FAT(unsigned long Sector, unsigned char *Buf);      //   FAT
unsigned char Is_DF_Ready(void);                                //   
void DF_ClearLog(void);                                         // 
unsigned long DF_GetLogSize(void);                              //  
void DF_WrLogPar(void);                                         //   
void DF_DelayedWrLogPar(void);                                  //   
//  
void DF_WrLogRec(unsigned char *Text, signed short A1, signed short A2, signed short A3);
//  
unsigned short DF_RdLogRec(unsigned char *Text, unsigned long NRecFromEnd);
//   Flash
void SaveObj(unsigned long StorAdr, unsigned char *Data, unsigned short DataLen);
//   Flash
void LoadObj(unsigned long StorAdr, unsigned char *Data, unsigned short DataLen);
unsigned char IsFlashClear(void);                               //    Flash
void ApdBootInf(void);                                          //        DF

#endif  //DF_SERVICE_H
